/* File:    Tachometer_gcc.c
 * 
 * Author:  David Zemon
 * Project: Tachometer_gcc
 */

// Includes
#include "Tachometer_gcc.h"

// Global variables
static uint32 average;
extern uint32 *_load_start_cogtachometer;

// Main function
void main (void) {
	uint8 tachCog;
	uint32 rpm = 0;
	uint32 oldAverage;
	float divisor;
//	cognew(blinky, 0);

	sysInit(&tachCog, &divisor);

	GPIODirModeSet(TEST_LED, GPIO_DIR_OUT);

	waitcnt(CLKFREQ * 3 + CNT);

	while (1) {
		oldAverage = average;
		rpm = divisor / oldAverage;
		if (MAX_RPM < rpm)
			rpm = 0;
		printf("RPM: %u\n", rpm);
		while (oldAverage == average)
			;
	}
}

void sysInit (uint8 *tachCog, float *divisor) {
	printf("Hello. Starting tachometer code...\n");
	*tachCog = cognew(_load_start_cogtachometer, &average);
	while (-1 == *tachCog) {
		// Infinite loop if failed to start tachometer cog
	}

	*divisor = CLKFREQ;
	*divisor *= TICKS_PER_REV * 15;
}

void tachometer (void) {
	uint32 sum, old, new, count, final;
	uint32 rollingArray[ARRAY_SIZE];
	uint32 index;
	uint8 full;

	// Ignore the first period
	waitpeq(TACH_PIN, TACH_PIN);
	waitpeq(0, TACH_PIN);

	// Initialize variables
	sum = 0;
	index = 0;
	full = 0;
	old = CNT;
	GPIODirModeSet((TEST_LED | TEST_LED_2), GPIO_DIR_OUT);

	while (1) {
		// Measure time lapse since last tick
		waitpeq(TACH_PIN, TACH_PIN);
		new = CNT;
		waitpeq(0, TACH_PIN);
		// Hold execution until end of half-period
		count = new - old;
		old = new;

		GPIOPinToggle(TEST_LED_2);

		// Add the new value and if the array is full subtract the oldest value
		sum += count;
		if (full)
			sum -= rollingArray[index];

		// Store the current value, increment the index, roll the index back to 0 if necessary
		rollingArray[index++] = count;
		if (ARRAY_SIZE == index) {
			index = 0;
			full = 1;
		}

		// Write the new average to
		if (full) {
			printf("%u\n", average);
			average = sum >> LOG_SIZE; // Divide the sum by ARRAY_SIZE
		}
	}
}
